#include "options.h"
#include "aClient.h"
#include "extern.h"
#include "flags.h"
#include "player.h"
#include "item.h"
#include "pouch.h"

#include <fstream>
#include <iostream>
#include <list>
#include <algorithm>

int sock = 1;

using namespace std;

char *PACKAGE = "GameServ";
char *VERSION = "1.3.2 +devel";

long lastrefresh;
long lastrollover;

list<aClient*> clients[U_TABLE_SIZE];
list <item*> items;

void save_lastrefresh();
void load_lastrefresh();
void prettyIntro();
void check_idles();

int main(int argc, char *argv[])
{
    char buffer[1024], buf[1024];
    memset(buffer, 0, 1024);
    memset(buf, 0, 1024);
    int connected;

    char *conf;
    srand(time(NULL));
    conf = new char[16];
    strcpy(conf, "gameserv.conf");

  /*
   * This needs to be fixed to work for any number of arguments in any
   * order
   *
   */
  if (argc > 1)
  {
	if ( argc > 2 || stricmp(argv[1], "--help") == 0)
	{
	    cout << "Usage: gameserv [options] [configfile]" << endl;
	    cout << "Options:" << endl;
	    cout << "--help                        Displays this help dialogue" << endl;
	    return 1;
	}
	delete []conf;
	conf = argv[1];
  }

  prettyIntro();

  if (load_config_file(conf))
  {
  	cout << "Config file loaded ok...\n"
             << "Turning into a daemon" << endl;
  }
  else
  	exit(2);

    if (argc <= 1)
	delete []conf;

    // Turn into a daemon
    /*
    if (daemon(1,0) < 0)
    {
        perror("Could not turn into a daemon");
        exit(3);
    }
    */

  load_gs_dbase();
  loadNews(newsdata, todaysnews);

  if (load_masters() == false)
  {
	log("Error loading masters");
	goto end;
  }

  if (load_monsters() == false)
  {
	log("Error loading monsters");
	goto end;
  }

  if (!load_dragon())
  {
	log("Error loading dragon");
	goto end;
  }

  if (load_levels() == false)
  {
	log("Error loading levels");
	goto end;
  }

    shuttingdown = false;

    char ignoreservers[32][256];
    char *currentserver;
    currentserver = strtok(ignoreserverslist, " ");
    for (int server = 0; server < 32 && currentserver != NULL; server++)
    {
	strncpy(ignoreservers[server], currentserver, 255);
	log("Placing %s on the server ignore list", currentserver);
	currentserver = strtok(NULL, " ");
    }

 // This loop will retry the connection 3 times
      connected = 1;
      load_lastrefresh();
 
	  {
	    aClient *tempPtr, *tempPtr2;

		list<aClient*>::iterator iter;
		char *nick = "testing";
		unsigned long hv = iHASH((unsigned char *) nick);
		tempPtr = new aClient(nick);
		tempPtr2 = new aClient("testing2");

		tempPtr->stats = new Player;
		clients[hv].push_back(tempPtr);
		clients[hv].push_back(tempPtr);
		clients[hv].push_back(tempPtr);
		clients[hv].push_back(tempPtr);
		clients[hv].push_back(tempPtr2);
		clients[hv].push_back(tempPtr2);
		clients[hv].push_back(tempPtr2);
		delete tempPtr->stats;
		
		
		tempPtr = find(nick);

		
		//iter = find((clients[0].begin()), (clients[0].end()), tempPtr);
		//		cout << "Nick: " << (*iter)->getNick() << endl;
		clients[hv].remove(tempPtr);
		for (unsigned long x = 0; x < U_TABLE_SIZE; x++)
		  {
			for (iter = clients[x].begin(); iter != clients[x].end(); iter++)
			  {
				cout << (*iter)->getNick() << endl;
			  }
		  }
	  
	  }
    {
      // This is where you can test stuff
      /*
	string itemname;
	item *tempitem;
	
	cout << "Enter an item name: ";
	cin >> itemname;
	char num[16];
	for (int x = 1; x < 6000001; x++)
	{
	sprintf(num, "%d", x);
	tempitem = new weapon((itemname + num));
	items.push_back(tempitem);
	}
	
	item *tester = items.front();
	cout << tester->getName() << endl;
	item *tester2 = items.back();
	cout << tester2->getName() << endl;
	items.clear();
      */
    }

 end:    

    save_gs_dbase();
    save_dragon();
    saveNews(newsdata, todaysnews);
    
    delete_monsters();
    
#ifdef DEBUGMODE
    log("<CLOSED>");
#endif
    
    unload_config_file();
    return 0;
}

aClient *find(char *nick)
{
  return findbynick(nick);
}

aClient *find(const char *nick)
{
  return findbynick(nick);
}

#ifdef P10

aClient *findbyrealnick(char *realnick)
{
  ListNode <aClient*> *newPtr;
  unsigned long hv = sHASH((unsigned char *) realnick);
  newPtr = clients[hv].First();
  
  aClient *client = NULL;
  
  while (newPtr)
    {
      client = newPtr->getData();
      if (stricmp(client->getRealNick(), realnick) == 0)
	return client;
      client = NULL;
      newPtr = newPtr->Next();
    }
  return client;    
}

#else

aClient *findbyrealnick(char *realnick)
{
  return findbynick(realnick);
}

#endif

aClient *findbynick(char *nick)
{
  list<aClient*>::iterator iter;
#ifdef P10
  unsigned long hv = sHASH((unsigned char *) nick);
#else
  unsigned long hv = iHASH((unsigned char *) nick);
#endif
  
  aClient *client = NULL;
  
  for(iter = clients[hv].begin(); iter != clients[hv].end(); iter++)
	{
	  client = (*iter);
#ifdef P10
	  if (strcmp(client->getNick(), nick) == 0)
		{
#else
	  if (stricmp(client->getNick(), nick) == 0)
		{
#endif
		  return client;
		}
	  client = NULL;
   	}
  return client;
}
  
aClient *findIRCplayer(const char *nick)
{
  list<aClient*>::iterator iter;
  aClient *p = NULL;
  
  p = find(nick);
  
  if (!is_playing(p))
	return NULL;
  
  unsigned long hv = iHASH((unsigned char *) p->stats->getName().c_str());
  
  for (iter = players[hv].begin(); iter != players[hv].end(); iter++)
	{
	  p = (*iter);
#ifdef P10
	  if (strcmp(p->getNick(), nick) == 0)
		{
#else
	  if (stricmp(p->getNick(), nick) == 0)
		{
#endif
		  return p;
		}
	  p = NULL;
	}
  return NULL;
}
  aClient *findplayer(const char *name)
	{
	  list<aClient*>::iterator iter;
	  Player *p = NULL;
	  unsigned long hv = iHASH((unsigned char *) name);
	  for (iter = players[hv].begin(); iter != players[hv].end(); iter++)
		{
		  p = (*iter)->stats;
		  if (stricmp(p->getName().c_str(), name) == 0)
			return (*iter);
		  p = NULL;
		}
	  return NULL;
	}
  
  void check_idles()
	{
	  list<aClient*>::iterator iter;

	  Player *p = NULL;

	  for (int x = 0; x < U_TABLE_SIZE; x++)
		{
		  for (iter = players[x].begin(); iter != players[x].end(); iter++)
			{
			  p = (*iter)->stats;

			  switch(p->getLevel())
				{
				case 1:
				  if ((time(NULL) - p->lastlogin) / 86400 >= level1expire)
					{
					  logout((*iter));
					  players[x].remove((*iter));
					  return;
					}
				  break;

				default:
				  if ((time(NULL) - p->lastlogin) / 86400 >= defaultexpire)
					{
					  logout((*iter));
					  players[x].remove((*iter));
					  return;
					}
				  break;
				}
			  if (timedOut(p))
				{
				  timeOutEvent(p);
				}
			}
		}
	}
  
  aClient *findbynick(const char *nick)
	{
	  list<aClient*>::iterator iter;
#ifdef P10
	  unsigned long hv = sHASH((unsigned char *) nick);
#else
	  unsigned long hv = iHASH((unsigned char *) nick);
#endif

	  aClient *client = NULL;

	  for (iter = clients[hv].begin(); iter != clients[hv].end(); iter++)
		{
		  client = (*iter);
#ifdef P10
		  if (strcmp(client->getNick(), nick) == 0)
#else
			if (stricmp(client->getNick(), nick) == 0)
#endif
			  return client;
		  client = NULL;
		}
	  return client;
	}
  
void prettyIntro()
{
  cout << endl;
  cout << "  GGGG     AAA   MM    MM EEEEEEE  SSSSS  EEEEEEE RRRRRR  VV     VV " << endl;
  cout << " GG  GG   AAAAA  MMM  MMM EE      SS      EE      RR   RR VV     VV " << endl;
  cout << "GG       AA   AA MM MM MM EEEEE    SSSSS  EEEEE   RRRRRR   VV   VV  " << endl;
  cout << "GG   GGG AAAAAAA MM    MM EE           SS EE      RR  RR    VV VV   " << endl;
  cout << "G     G  AA   AA MM    MM EEEEEEE  SSSSS  EEEEEEE RR   RR    VVV" << endl;
  cout << " GGGGG                                                        V\n\n" << endl;
  cout << "Version: " << VERSION << endl;
}

void load_lastrefresh()
{
  ifstream infile;
  infile.open(".gsrefresh");
  if (infile.fail())
    {
#ifdef DEBUGMODE
      log("Error opening .gsrefresh");
#endif
      
    generate:
      long mytime = time(NULL);
#ifdef DEBUGMODE
      log("Generating new refresh time");
#endif
      
      // Just a safety measure... tho no one should
      // get anywhere near the time as their refreshperiod
      if (refreshperiod >= mytime)
	refreshperiod = 86400;
      
      lastrefresh = mytime - (mytime % refreshperiod);
      refreshall();
      save_lastrefresh();
      return;
    }
  infile >> lastrefresh;
  infile.close();
  if (lastrefresh < 0)
    goto generate;
}

void save_lastrefresh()
{
  ofstream outfile;
  
  outfile.open(".gsrefresh");
  
  if (outfile.fail())
    {
      log("Error creating new file .gsrefresh");
      return;
    }
  outfile << lastrefresh << endl;
  
  outfile.close();
}
