#include "extern.h"
#include "aClient.h"
#include "flags.h"
#include "options.h"
#include "player.h"

void do_reset(char *u)
{
  char *nick = strtok(NULL, " ");
  aClient *user;
  Player *p;
  
  if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Error: aClient not found. Contact a <S admin");
	  log("Error: aClient not found: %s", u);
	  return;
    }
  else if (!isAdmin(user))
    {
	  notice(s_GameServ, u, "You must be a <S admin to use this command!");
	  return;
    }
  
  if (!nick)
    {
	  notice(s_GameServ, u, "SYNTAX: RESET {ALL | NICK}");
    }
  else if (stricmp(nick, "ALL") == 0)
    {
	  notice(s_GameServ, u, "Resetting everyone's stats!");
	  resetall();
    }
  else if (!(p = findplayer(nick)))
	{
	  notice(s_GameServ, u, "Nick %s not found.", nick);
	}
  else
    {
	  notice(s_GameServ, u, "Resetting %s.", p->getName().c_str());
	  reset(p);
	}
}
