#include "extern.h"
#include "aClient.h"
#include "flags.h"
#include "options.h"

void do_stats(char *u)
{
  char *nick;
  aClient *user;
  
  nick = strtok(NULL, " ");
  
  if (!(user = find(u)))
    {
	  log("Fatal Error: %s not found in client list", u);
	  return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  else if (!nick)
    {
	  if (!is_playing(user))
		{
		  notice(s_GameServ, u, "You're not playing, so you have no stats!");
		  return;
		}
	  else
		{
		  if (!is_fighting(user))
			updateTS(user->stats);
		  showstats(u, user->stats->getName().c_str());
		}
    }
  else
	showstats(u, nick);
}
