#include "extern.h"
#include "aClient.h"
#include "flags.h"
#include "options.h"
#include "item.h"
#include "pouch.h"

void do_use(char *u)
{
  aClient *user;
  pouch *p;
  
  char *item = strtok(NULL, " ");
  char *numuse = strtok(NULL, " ");
  int id, num;
  itemContainer *used;
  
  if (!item || int(item[0]) < 48 || int(item[0]) > 57 || (numuse && (int(numuse[0]) < 48 || int(numuse[0]) > 57)))
    {
	  notice(s_GameServ, u, "SYNTAX: USE ####");
	  notice(s_GameServ, u, "Type /msg <S HELP USE for more information.");
	  return;
    }
  else if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Fatal Error in do_use. Contact a(n) <S Admin");
	  return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  else if (!is_playing(user))
    {
	  notice(s_GameServ, u, "You must be playing to use items!");
	  return;
    }
  id = stringtoint(item);
  
  if (!numuse)
	{
	  num = 1;
	}
  else
	{
	  num = stringtoint(numuse);
	}
  
  updateTS(user->stats);
  p = user->stats->inventory;
  

  if (!(used = p->Find(id)))
	{
	  if (!p->isEmpty())
		{
		  notice(s_GameServ, u, "You aren't carrying that item!");
		}
	  showinventory(user->stats, user);
	}
  else if (used->getItem()->getType() != POTION)
	{
	  notice(s_GameServ, u, "You can't use %s like that. Try /msg <S equip", used->getItem()->getName().c_str());
	}
  else
	{
	  // Use the item(s)
	  if (num <= 1 || is_fighting(user))
		{
		  notice(s_GameServ, u, "You used %s.", used->getItem()->getName().c_str());
		  used->use(user->stats);
		  if (used->getUses() <= 0)
			{
			  p->deleteItem(used->getItem());
			}
		  end_turn(user);
		}
	  else if (num > 1)
		{
		  int count;
		  const char *name = used->getItem()->getName().c_str();
		  for (count = 0; count < num; count++)
			{
			  if (!(used = p->Find(id)))
				{
				  break;
				}
			  else
				{
				  used->use(user->stats);
				  if (used->getUses() == 0)
					{
					  p->deleteItem(used->getItem());
					}
				}
			}
		  notice(s_GameServ, u, "You used %d %s's", count, name);
		}
	}
}

