#include "extern.h"
#include <list>
#include <iterator>
#include <fstream>
#include <string>
#include <stdio.h>
#include <string.h>  

using namespace std;

list<string> todaysnews;
void addNews(list<string> &news, const char *fmt, ...);
void clearNews(list<string> &news) {news.clear();};
void showNews(char *nick, list<string> &news);
void saveNews(char *filename, list<string> &news);
void loadNews(char *filename, list<string> &news);

void addNews(list<string> &news, const char *fmt, ...)
{
  if (fmt[0] == '\0')
	return;
  
  va_list args;
  char *input;
  input = new char[1024];
  memset(input, 0, 1024);
  const char *t = fmt;
  
  va_start(args, fmt);
  
  for (; *t; t++)
    {
	  if (*t == '%')
        {
		  switch(*++t) {
		  case 'd': sprintf(input, "%s%d", input, va_arg(args, int)); break;
		  case 's': sprintf(input, "%s%s", input, va_arg(args, char *)); break;
		  case 'S': sprintf(input, "%s%s", input, s_GameServ); break;
		  case 'l':
			if (*++t == 'd')
			  sprintf(input, "%s%ld", input, va_arg(args, long int)); break;
		  }
        }
	  else
        {
		  sprintf(input, "%s%c", input, *t);
        }
	  
    }
#ifdef DEBUGMODE
  log("New News Item: %s", input);
#endif
  
  notice(s_GameServ, c_Forest, "News Flash: %s", input);
  string *nstring;
  nstring = new string(input);
  news.push_back(*nstring);
  
  delete [] input;
  delete nstring;
  
  va_end(args);
}

void showNews(char *nick, list<string> &news)
{
  if (!news.empty())
    {
	  list<string>::iterator iter;
	  
	  notice(s_GameServ, nick, "The Daily Happenings: ");
	  for (iter=news.begin(); iter != news.end(); iter++)
		{
		  notice(s_GameServ, nick, "%s", (*iter).c_str());
		}
	  notice(s_GameServ, nick, "End of News");
    }
}

void saveNews(char *filename, list<string> &news)
{
  ofstream outfile;
  outfile.open(filename);
  
  if (outfile.fail())
    {
	  log("Error opening %s", filename);
	  return;
    }
  
  list<string>::iterator iter;
  for (iter=news.begin(); iter != news.end(); iter++)
	{
	  outfile << (*iter).c_str() << endl;
    }
  outfile.close();
}

void loadNews(char *filename, list<string> &news)
{
  // First clear the old news out
  news.clear();
  
  // Now load from the file
  ifstream infile;
  infile.open(filename);
  if (infile.fail())
	{
	  log("Error opening %s", filename);
	  return;
	}
  
  char *buf;
  string *str;
  buf = new char [1024];
  
  while (infile.getline(buf, 1024, '\n'))
	{
	  if (buf[0] == '\0' || buf[0] == '\n')
		{
		  delete [] buf;
		  return;
		}
	  str = new string(buf);
	  news.push_back(*str);
	  delete str;
	}
  
  delete [] buf;
}

void do_news(char *u)
{
  showNews(u, todaysnews);
}
