
#include "script.h"
#include "extern.h"
#include "player.h"
#include <fstream>
#include <string>
#include <string.h>  

using namespace std;

script::script()
{
  scriptstr = "";
}

script::script(string &str)
{
  scriptstr = str;
}

script::script(const char *str)
{
  scriptstr = str;
}

script::~script()
{
  scriptstr = "";
}

void script::setString(string &str)
{
  scriptstr = str;
}

void script::setString(const char *str)
{
  scriptstr = str;
}

bool script::executeScript(Player *p)
{
  string line;
  string::size_type begin = 0;
  string::size_type end = scriptstr.find("\n", 0);
  char *left, *op, *right, *buffer;
  void *leftptr;

  while (end != string::npos)
	{
	  // Get the line based on what we just found
	  line = scriptstr.substr(begin, end - begin);

	  log("Line: %s", line.c_str());

	  if (line.c_str()[0] != '#')
		{
		  // Not a comment
		  buffer = new char[line.length()];

		  left = strtok(buffer, " ");
		  op = strtok(NULL, " ");
		  right = strtok(NULL, " ");

		  if (stricmp(left, "GOLD") == 0)
			{
			  leftptr = (void*)p->gold;
			}
		  else if (stricmp(left, "STRENGTH") == 0)
			{
			  leftptr = (void*)p->strength;
			}
		}
	   
	  // Find the next line
	  begin = end + 1;
	  end = scriptstr.find("\n", begin);
	}
  return true;
}

bool script::loadScript(const char *filename)
{
  char *buffer;
  int length;
  ifstream infile;
  bool result;

  infile.open(filename, ios::binary);

  if (infile.fail())
	{
	  log("Error opening script %s", filename);
	  return false;
	}

  // get length of file:
  infile.seekg (0, ios::end);
  length = infile.tellg();
  infile.seekg (0, ios::beg);

  if (length > 0)
	{ 
	  buffer = new char[length];
	  infile.read(buffer, length);
	  scriptstr = buffer;
	  delete [] buffer;
	  result = true;
	}
  else
	{
	  result = false;
	}
  infile.close();
  return result;
}
