 /* This file contains functions dealing with strings */
 
 #include "extern.h"
 #include "config.h"
 #include <string.h>
 #include <cstdlib> 
 
 // String functions
#ifndef HAVE_STRTOK
char *strtok(char *str, const char *delim);
#endif

int stricmp(const char *s1, const char *s2);
int strnicmp(const char *s1, const char *s2, size_t len);
// String Functions

int stricmp(const char *s1, const char *s2)
{
    register int c;

    while ((c = tolower(*s1)) == tolower(*s2)) {
        if (c == 0)
            return 0;
        s1++;
        s2++;
    }
    if (c < tolower(*s2))
        return -1;
    return 1;
}



string spaces(int len, const string &seperator)
{
    string final;
    int y;
    final += seperator;

    for (y = 0; y < 30 - len; y++)
        final += seperator;

    return final;
}



int strnicmp(const char *s1, const char *s2, size_t len)
{
    register int c;

    if (!len)
        return 0;
    while ((c = tolower(*s1)) == tolower(*s2) && len > 0) {
        if (c == 0 || --len == 0)
            return 0;
        s1++;
        s2++;
    }
    if (c < tolower(*s2))
        return -1;
    return 1;
}

#ifndef HAVE_STRTOK
char *strtok(char *str, const char *delim)
{
    static char *current = NULL;
    char *ret;

    if (str)
        current = str;
    if (!current)
        return NULL;
    current += strspn(current, delim);
    ret = *current ? current : NULL;
    current += strcspn(current, delim);
    if (!*current)
        current = NULL;
    else
        *current++ = 0;
    return ret;
}
#endif

int isstringnum(char *num)
{
    unsigned int x;
    for (x = 0; x < strlen(num); x++)
    {
        if ((int)num[x] < 48 || (int)num[x] > 57)
            return 0;
    }
return 1;
}

long int stringtoint(char *number)
{
    return atol(number);
}

long int pow(int x, int y)
{
  long int value = 0;
  int count = 0;
  value += x;
  
  if (x != 0 && y != 0)
    {
	  for (count = 1; count <= y - 1; count++)
		value *= x;
    }
  else
	{
	  return 1;
	}
  return value;
}

long int chartoint(char ch)
{
  if (int(ch) >= 48 && int(ch) <= 57)
	return int(ch) - 48;
  else
	return 0;
}
