#include "toplist.h"
#include "player.h"
#include <list>

using namespace std;

toplist::toplist()
{
  myList.clear();
  count = 10;
}

toplist::toplist(int c)
{
  myList.clear();
  count = c;
}

toplist::~toplist()
{
  myList.clear();
  count = 10;
}

void toplist::insertPlayer(Player *p)
{
   PlayerWrapper *pw;
   pw = new PlayerWrapper(p);
   myList.push_front(*pw);
   sort();

   // Reverse the list since list::sort() uses the < operator
   reverse();
   prune();
}

void toplist::setCount(int c)
{
  count = c;
}

void toplist::sort()
{
  myList.sort();
}

void toplist::reverse()
{
   myList.reverse();
}
void toplist::prune()
{
  list<PlayerWrapper>::iterator it;
  it = myList.begin();

  for (int x = 0; it != myList.end(); x++, it++)
	{
	  if (x > count)
		{
		  // Delete this player from the top list, because they're over the count
		  myList.erase(it);
		}
	}
}

list<PlayerWrapper>::iterator toplist::begin()
{
  return myList.begin();
}


list<PlayerWrapper>::iterator toplist::end()
{
  return myList.end();
}

bool toplist::empty()
{
    return myList.empty();
}

bool PlayerWrapper::operator < (PlayerWrapper &right)
{
   return (*p < *right.p);
}

PlayerWrapper::PlayerWrapper()
{
   p = NULL;
}

PlayerWrapper::PlayerWrapper(Player *pl)
{
   p = pl;
}

PlayerWrapper::~PlayerWrapper()
{
   p = NULL;
}

void PlayerWrapper::setPlayer(Player *pl)
{
   p = pl;
}

